#define WIN32_LEAN_AND_MEAN
#define INITGUID

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <mmsystem.h>
#define   DIRECTDRAW_VERSION 0x0300
#include <ddraw.h>
#include <dsound.h>
#include "md.h"

#include <math.h>

#define KEY_DOWN(vk_code) ((GetAsyncKeyState(vk_code) & 0x8000) ? 1 : 0)

static HWND  hWnd; // Main window handle.
static md megad;
static int ret;
static int crap_tv=0;

FILE *debug_log=NULL;

static int fullscreen=0,width=320,height=240,depth=16;
static int force_depth=0;
static char temp[0x8000];
static int we_are_active=1;

//static PALETTEENTRY ape[256]={0};
//static IDirectDrawPalette *ddpal=0;
static float umul=1.2,vmul=1.2,brightness=0.1,contrast=0.8;
static int virtual_fps=60,any_size=0;

//static REAL_FMSAM *fm_buffer[2]={NULL};
static REAL_FMSAM *fmbuf[2]={NULL};
static int snd_size=367*1,snd_rate=22050*1,snd_segs=4,stereo16=1;
static float snd_distort=1.00;
static IDirectSound *lpds=NULL;
static IDirectSoundBuffer *lpBufPrim,*lpBuf;
int sound_is_okay=0;

static int sound_init()
{
  snd_size=snd_rate/virtual_fps; if (snd_size<16) snd_size=16;

//  sound_is_okay=0; return 1; // turn off sound

  ret=DirectSoundCreate(NULL, &lpds, NULL);
  if (ret!=DS_OK)
	{
    sound_is_okay=0; return 1; // turn off sound
	}

  ret=lpds->SetCooperativeLevel(hWnd, DSSCL_PRIORITY);
  if (ret!=DS_OK)
  {
    sprintf (temp,"returned %.8x (+%d)\n",ret,ret-MAKE_DSHRESULT(0));
    MessageBox(hWnd,temp,"lpds->SetCooperativeLevel()",MB_OK);
    if (ret!=DS_OK) goto snd_fail;
  }

	PCMWAVEFORMAT	pcmwf;
	WAVEFORMATEX	wf;

	memset(&pcmwf, 0, sizeof(PCMWAVEFORMAT)); 
	memset(&wf,0,sizeof(WAVEFORMATEX));
  pcmwf.wBitsPerSample = stereo16? 16:8; 
	pcmwf.wf.wFormatTag = WAVE_FORMAT_PCM; 
  pcmwf.wf.nChannels = stereo16? 2:1 ; 
  pcmwf.wf.nSamplesPerSec = snd_rate;
	pcmwf.wf.nBlockAlign = pcmwf.wf.nChannels * (pcmwf.wBitsPerSample/8); 
	pcmwf.wf.nAvgBytesPerSec = pcmwf.wf.nSamplesPerSec * pcmwf.wf.nBlockAlign; 
	//
	wf.wFormatTag = WAVE_FORMAT_PCM;
	wf.nChannels = pcmwf.wf.nChannels;
	wf.nSamplesPerSec = pcmwf.wf.nSamplesPerSec;
	wf.wBitsPerSample = pcmwf.wBitsPerSample;
	wf.nBlockAlign = pcmwf.wf.nBlockAlign;
	wf.nAvgBytesPerSec = pcmwf.wf.nAvgBytesPerSec;
	wf.cbSize = sizeof(WAVEFORMATEX);

	//--PrimaryBuffer make
	DSBUFFERDESC dsbdesc;
  memset(&dsbdesc, 0, sizeof(DSBUFFERDESC));
  dsbdesc.dwSize = sizeof(DSBUFFERDESC);
  dsbdesc.dwFlags = DSBCAPS_PRIMARYBUFFER;
  ret=lpds->CreateSoundBuffer(&dsbdesc,&lpBufPrim,NULL);
  if (ret!=DS_OK)
  {
    sprintf (temp,"returned %.8x (+%d)\n",ret,ret-MAKE_DSHRESULT(0));
    MessageBox(hWnd,temp,"create primary buffer",MB_OK);
    if (ret!=DS_OK) goto snd_fail;
  }
  ret=lpBufPrim->SetFormat(&wf);
  if (ret!=DS_OK)
  {
    sprintf (temp,"returned %.8x (+%d)\n",ret,ret-MAKE_DSHRESULT(0));
    MessageBox(hWnd,temp,"primary buffer set format",MB_OK);
    if (ret!=DS_OK) goto snd_fail;
  }
  ret=lpBufPrim->Play(0,0,DSBPLAY_LOOPING);
  if (ret!=DS_OK)
  {
    sprintf (temp,"returned %.8x (+%d)\n",ret,ret-MAKE_DSHRESULT(0));
    MessageBox(hWnd,temp,"primary buffer play",MB_OK);
    if (ret!=DS_OK) goto snd_fail;
  }

	//--SecondaryBuffer Make
  memset(&dsbdesc, 0, sizeof(DSBUFFERDESC));
  dsbdesc.dwSize = sizeof(DSBUFFERDESC);
  dsbdesc.dwFlags = DSBCAPS_CTRLDEFAULT  | DSBCAPS_GETCURRENTPOSITION2 | DSBCAPS_STICKYFOCUS;
  dsbdesc.dwBufferBytes = snd_size*snd_segs*(stereo16?4:1); 
  dsbdesc.lpwfxFormat = (LPWAVEFORMATEX)&pcmwf;

  ret=lpds->CreateSoundBuffer(&dsbdesc,&lpBuf,NULL);
  if (ret!=DS_OK)
  {
    sprintf (temp,"returned %.8x (+%d)\n",ret,ret-MAKE_DSHRESULT(0));
    MessageBox(hWnd,temp,"create secondary sound buffer",MB_OK);
    if (ret!=DS_OK) goto snd_fail;
  }

	LPVOID ptr1, ptr2;
	DWORD  size1, size2;
  ret=lpBuf->Lock(0,snd_size,&ptr1, &size1, &ptr2, &size2, 0);
  if (ret == DS_OK)
  {
    lpBuf->Unlock(ptr1, size1, ptr2, size2);
  }

  ret=lpBuf->Play(0,0,DSBPLAY_LOOPING);
  if (ret!=DS_OK)
  {
    sprintf (temp,"returned %.8x (+%d)\n",ret,ret-MAKE_DSHRESULT(0));
    MessageBox(hWnd,temp,"play secondary sound buffer",MB_OK);
    sound_is_okay=0;
  }

  fmbuf[0]=(REAL_FMSAM *)malloc(snd_size*sizeof(REAL_FMSAM));
  if (fmbuf[0]==NULL) exit(1);
  fmbuf[1]=(REAL_FMSAM *)malloc(snd_size*sizeof(REAL_FMSAM));
  if (fmbuf[1]==NULL) exit(1);

  memset(fmbuf[0],0,snd_size*sizeof(REAL_FMSAM));
  memset(fmbuf[1],0,snd_size*sizeof(REAL_FMSAM));

  // meant to be 53693100L/8 ?
  ret=YM2612Init(1,(int)(8000000L*94/100),(int)((double)snd_rate/snd_distort),NULL,NULL);
  if (ret!=0)
  {
    sprintf (temp,"YM2612Init returned %d\n",ret);
    MessageBox(hWnd,temp,"YM2612Init",MB_OK);
    if (ret!=0) goto snd_fail;
  }

  ret=SN76496_init(1,53693100L/11,(int)((double)snd_rate/snd_distort),16);
  if (ret!=0)
  {
    sprintf (temp,"SN76496_init returned %d\n",ret);
    MessageBox(hWnd,temp,"SN76496_init",MB_OK);
//    if (ret!=0) goto snd_fail;
  }


  sound_is_okay=1;


  return 0;
snd_fail:
  return 1;
}

static int fill_snd_seg(int fillseg)
{
  LPVOID ptr1, ptr2;
	DWORD  size1, size2;

  if (fillseg<0) return 1;
  if (fillseg>=snd_segs) return 1;

  ret=lpBuf->Lock(fillseg*snd_size*(stereo16?4:1),snd_size*(stereo16?4:1),&ptr1,&size1,&ptr2,&size2,0);
  if (ret!=DS_OK || ptr2 || size2 || size1!=snd_size*(stereo16?4:1))
  {
    sprintf (temp,"returned %.8x (+%d) WANTED seg %d ptr1=%p,%x ptr2=%p,%x\n",ret,ret-MAKE_DSHRESULT(0),
      fillseg,ptr1,size1,ptr2,size2);
    MessageBox(hWnd,temp,"lpBuf->Lock",MB_OK);
    //if (ret!=DS_OK)
    sound_is_okay=0;
  }
  if (ret == DS_OK)
  {
    signed short *newsnd16; unsigned char *newsnd8;
    newsnd16=(signed short *)ptr1;
    newsnd8=(unsigned char *)ptr1;
    if (ptr1!=NULL)
    {
      REAL_FMSAM *mame_buf[2];
      int j;

      mame_buf[0]=fmbuf[0];
      mame_buf[1]=fmbuf[1];
      for (j=0;j<snd_size;j++)
      {
        int disp;
        if (stereo16)
        {
          newsnd16[j*2+0]=mame_buf[0][j];
          newsnd16[j*2+1]=mame_buf[1][j];
        }
        else
        {
          disp=0;
          disp+=((int)mame_buf[0][j]);
          disp+=((int)mame_buf[1][j]);
          disp>>=9;
          newsnd8[j]=disp+0x80;
        }
      }
/*
      FILE *hand=fopen("sound.log","ab");
      if (hand!=NULL)
      {
        fwrite(ptr1,1,snd_size*(stereo16?4:1),hand);
        fclose(hand);
      }
*/
    }
    lpBuf->Unlock(ptr1, size1, ptr2, size2);
  }

  return 0;
}


static int sound_exit()
{
  if (sound_is_okay)
  {
    //-- DirectSound Cleanup
    if(lpBuf)   lpBuf->Release();
    if(lpBufPrim) lpBufPrim->Release();
    if(lpds)    lpds->Release();
    YM2612Shutdown();

    if (fmbuf[0]!=NULL) free(fmbuf[0]); fmbuf[0]=NULL;
    if (fmbuf[1]!=NULL) free(fmbuf[1]); fmbuf[1]=NULL;
  }

  sound_is_okay=0;
  return 0;
}

static char *gst_name(char *fn)
{
  char *pt,*st;
  int len;

  temp[0x200]=0;
  pt=fn+strlen(fn)-1;
  while (pt>fn)
  {
    if (*pt=='\\') {pt++; break; }
    pt--;
  }
  st=pt;
  len=0;
  while (*pt!=0)
  {
    if (*pt=='.') break; 
    pt++; len++;
  }
  memcpy(temp+0x200,st,len);
  temp[0x200+len]=0;

  return temp+0x200;
}

static inline int depth_to_bytes(int depth)
{
       if (depth<=8)  return 1;
  else if (depth<=16) return 2;
  else if (depth<=24) return 3;
  else                return 4;
}

static int mess_with_bm(struct bmap *bm)
{
  // Remember messy border - handy
  int x,y; unsigned char *line;
  if (bm->bpp!=16) return 1;
  if (!crap_tv) return 0;

  line=bm->data+8*bm->pitch+8*depth_to_bytes(bm->bpp);

  for (y=0;y<224;y++)
  {
    unsigned char *pix;

    pix=line;
    for (x=0;x<320-1;x++)
    {
      int tmp;
      int dot,dot2;
      dot= pix[0]|(pix[1]<<8);
      dot2=pix[2]|(pix[3]<<8);

      // Split g out from middle
      dot= ((dot &0x07e0)<<16) | (dot &0xf81f);
      dot2=((dot2&0x07e0)<<16) | (dot2&0xf81f);

      dot=(dot+dot2)>>1;

      // Put g back in middle
      dot= ((dot >>16) &0x07e0) | (dot &0xf81f);

      pix[0]=dot&255;
      pix[1]=(dot>>8)&255;

      pix+=2;
    }
    line+=bm->pitch;
  }

  return 0;
}

static int mess_with_pal(unsigned char pal[256])
{
  int i;
  if (pal==NULL) return 1;
  for (i=0;i<64;i++)
  {
    int ir,ig,ib;
    float y,u,v,r,g,b;
    ir=pal[i*4+0]; ig=pal[i*4+1]; ib=pal[i*4+2];

    r=((float)ir)/255.0;
    g=((float)ig)/255.0;
    b=((float)ib)/255.0;

    y=0.30*r+0.59*g+0.11*b;
    u=0.49*(b-y);
    v=0.88*(r-y);

    ir=ig=ib=0;

    y=(y*contrast)+brightness;
    u*=umul;
    v*=vmul;

    r=v/0.88+y;
    b=u/0.49+y;
    g=(y - 0.30*r - 0.11*b)/0.59;

    ir=(int)(r*255.0);
    ig=(int)(g*255.0);
    ib=(int)(b*255.0);

    if (ir<0) ir=0; if (ig<0) ig=0; if (ib<0) ib=0;
    if (ir>255) ir=255; if (ig>255) ig=255; if (ib>255) ib=255;

    pal[i*4+0]=ir; pal[i*4+1]=ig; pal[i*4+2]=ib;
  }
  return 0;
}

/*
static int put_in_ddraw_pal(unsigned char pal[1024])
{
  int i;
  if (ddpal==0) return 1;
  for (i=0;i<256;i++)
  {
    ape[i].peRed  =pal[i*4+0];
    ape[i].peGreen=pal[i*4+1];
    ape[i].peBlue =pal[i*4+2];
  }
  ddpal->SetEntries(0,0,256,ape);
  return 0;
}

static make_ddraw_pal(IDirectDraw *pdd)
{
  int i;
  if (pdd->CreatePalette(DDPCAPS_8BIT, ape, &ddpal, NULL)!=DD_OK)
    return 1;
  return 0;
}
*/

long int  PASCAL  MainWndProc(HWND, UINT, WPARAM, LPARAM);
BOOL InitApplication(HINSTANCE);

/***  Global Variables  ***/
char szName[256];
HINSTANCE hInst;  // current instance
/**********************************************************************/
BOOL InitApplication(HINSTANCE hInstance)
{
  WNDCLASS  wc;

  // Fill in window class structure with parameters that describe the
  // main window.

  wc.style = CS_HREDRAW | CS_VREDRAW; // Class style(s).
  wc.lpfnWndProc = MainWndProc; // Function to retrieve messages for
									 // windows of this class.
  wc.cbClsExtra = 0;  // No per-class extra data.
  wc.cbWndExtra = 0;  // No per-window extra data.
  wc.hInstance = hInstance; // Application that owns the class.
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH) GetStockObject(BLACK_BRUSH);
  wc.lpszMenuName = "CMDLGAPMENU";  // Name of menu resource in .RC file.
  wc.lpszClassName = "CMDLG"; // Name used in call to CreateWindow.

  /* Register the window class and return success/failure code. */

  return (RegisterClass(&wc));
}

/************************************************************************/
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{

  /* Save the instance handle in static variable, which will be used in  */
  /* many subsequence calls from this application to Windows.            */

  hInst = hInstance;

  /* Create a main window for this application instance.  */

  hWnd = CreateWindow(
	 "CMDLG",                 // See RegisterClass() call.
   "DGen v" VER,  // Text for window title bar.
	 WS_OVERLAPPEDWINDOW,        // Window style.
//	 CW_USEDEFAULT,         // Default horizontal position.
//	 CW_USEDEFAULT,          // Default vertical position.
//	 CW_USEDEFAULT,            // Default width.
//	 CW_USEDEFAULT,        // Default height.
80,40,(320+40),(224+55),
	 NULL,                  // Overlapped windows have no parent.
	 NULL,                  // Use the window class menu.
	 hInstance,              // This instance owns this window.
	 NULL                   // Pointer not needed.
  );

  /* If window could not be created, return "failure" */

  if (!hWnd)
	 return (FALSE);

  /* Make the window visible; update its client area; and return "success" */

  ShowWindow(hWnd, nCmdShow); // Show the window
  UpdateWindow(hWnd);     // Sends WM_PAINT message
  return (TRUE);        // Returns the value from PostQuitMessage

}


static unsigned char md_pal[1024]={0,0,0,0,255,255,255,0};
static IDirectDraw *lpdd=NULL;
static IDirectDrawSurface *lpDDSPrimary=NULL;
static IDirectDrawSurface *bufsurf=NULL;
static int create_primary_surface()
{
  //  (Creating Primary Surface)
  DDSURFACEDESC ddsd;
  //Clear all fields in structure
  memset( &ddsd, 0, sizeof(ddsd) );
  //Set flags in structure
  ddsd.dwSize = sizeof( ddsd );
  ddsd.dwFlags = DDSD_CAPS;
  ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
  //Create Surface
  ret = lpdd->CreateSurface(&ddsd, &lpDDSPrimary, NULL );
  if (ret!=DD_OK)
  {
    sprintf (temp,"Return value was %x (%+-d)\n",ret,ret-MAKE_DDHRESULT(0));
    MessageBox(hWnd,temp,"CreateSurface() failed",MB_OK);
    exit(1);
  }

  return 0;
}

static int attach_clipper()
{
  IDirectDrawClipper *clp=NULL;
  ret=lpdd->CreateClipper(0,&clp,NULL);
  if (ret!=DD_OK)
  {
    sprintf (temp,"Ret was %x (%+-d)\n",ret,ret-MAKE_DDHRESULT(0));
    MessageBox(hWnd,temp,"CreateClipper() failed",MB_OK);
  }
  else
  {
    ret=clp->SetHWnd(0,hWnd);
    if (ret!=DD_OK)
    {
      sprintf (temp,"Ret was %x (%+-d)\n",ret,ret-MAKE_DDHRESULT(0));
      MessageBox(hWnd,temp,"SethWnd failed",MB_OK);
    }
    else
    {
      ret=lpDDSPrimary->SetClipper(clp);
      if (ret!=DD_OK)
      {
        sprintf (temp,"Ret was %x (%+-d)\n",ret,ret-MAKE_DDHRESULT(0));
        MessageBox(hWnd,temp,"SetClipper(clp); failed",MB_OK);
      }
    }
  }
  return 0;
}

static int create_bufsurf()
{
  // Seems to default to Window's bpp anyway!

  DDSURFACEDESC ddsd;
  //Clear all fields in structure
  memset( &ddsd, 0, sizeof(ddsd) );
  //Set flags in structure
  ddsd.dwSize = sizeof( ddsd );
  ddsd.dwFlags = DDSD_CAPS|DDSD_WIDTH|DDSD_HEIGHT /*|DDSD_PIXELFORMAT*/;
  //ddsd.ddpfPixelFormat=pixfor;

  ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY;

  ddsd.dwWidth  = 320+16;
  ddsd.dwHeight = 224+16;
  ret=lpdd->CreateSurface(&ddsd,&bufsurf,NULL);
  if (ret!=DD_OK)
  {
    sprintf (temp,"ret was %x (%+-d) dwFlags is %.8x\n"
                   "ddsCaps.dwCaps is %.8x\n"
                   "%dx%d\n"
                   "lpSurface %p\n"
                   "lPitch %d\n"
                   "depth (dwRGBBitCount) %d\n"
                   "ddpfPixelFormat.dwFlags is %.8x\n"
                   ,ret
                   ,ret-MAKE_DDHRESULT(0)
                   ,ddsd.dwFlags
                   ,ddsd.ddsCaps.dwCaps
                   ,ddsd.dwWidth
                   ,ddsd.dwHeight
                   ,ddsd.lpSurface
                   ,ddsd.lPitch
                   ,ddsd.ddpfPixelFormat.dwRGBBitCount
                   ,ddsd.ddpfPixelFormat.dwFlags
                   );
    MessageBox(hWnd,temp,"DirectDrawSurface bufsurf",MB_OK);
    exit(1);
  }
  return 0;
}


static unsigned int frame_count=0;
static unsigned int start_time=0,end_time=0;

static int run_megadrive()
{
  DWORD posPlay,posWrite;
  int read_ptr=0;
  static int write_ptr=0;

  if (!megad.ok) return 1;
  if (bufsurf==NULL) return 1;

// Sound buffer loop round a number of segs of size snd_size
// SSSSSSSSS SSSSSSSSS SSSSSSSSS SSSSSSSSS 
//            Playing   Writing
  if (!sound_is_okay) return 1;

  lpBuf->GetCurrentPosition(&posPlay,&posWrite);

  read_ptr=posPlay/(snd_size*(stereo16?4:1));
  while (write_ptr!=read_ptr)
  {
    fill_snd_seg(write_ptr);

    // Now calculate the sound for the next seg
    megad.pad=0x303f; //      0x303f; = untouched pad
    if (we_are_active)
    {
      if (KEY_DOWN(0x26)) megad.pad&=~0x01;
      if (KEY_DOWN(0x28)) megad.pad&=~0x02;
      if (KEY_DOWN(0x25)) megad.pad&=~0x04;
      if (KEY_DOWN(0x27)) megad.pad&=~0x08;
  
      if (KEY_DOWN(0x0d)) megad.pad&=~0x2000;
      if (KEY_DOWN(0x41)) megad.pad&=~0x1000;
      if (KEY_DOWN(0x53)) megad.pad&=~0x10;
      if (KEY_DOWN(0x44)) megad.pad&=~0x20;
    }

    write_ptr=(write_ptr+1)%snd_segs;

    if (write_ptr!=read_ptr)
    {
      // Just the sound - don't need the picture yet
      megad.one_frame_hints(NULL,fmbuf,snd_size);
    }
    else
    {
      // Right - now we need the sound and the picture
      // Turn the buf surface into something we can write into
      DDSURFACEDESC sd;
      struct bmap sbm;
  
      memset(&sd,0,sizeof( sd ));
      sd.dwSize = sizeof( sd );
      ret=bufsurf->GetSurfaceDesc(&sd);
      if (ret!=DD_OK)
      {
        sprintf (temp,"ret is %x (%+-d)\n",ret,ret-MAKE_DDHRESULT(0));
        MessageBox(hWnd,temp,"GetSurfaceDesc(&sd) fail",MB_OK);
        exit(1);
      }
  
      sbm.w=sd.dwWidth;
      sbm.h=sd.dwHeight;
  
      DDPIXELFORMAT pf;
      memset(&pf,0,sizeof(pf));
      pf.dwSize = sizeof(pf);
      ret=bufsurf->GetPixelFormat(&pf);
      if (ret!=DD_OK)
      {
        sprintf (temp,"ret is %x (%+-d)\n",ret,ret-MAKE_DDHRESULT(0));
        MessageBox(hWnd,temp,"GetPixelFormat(&pf); fail",MB_OK);
        exit(1);
      }
  
      sbm.bpp=pf.dwRGBBitCount;
      if (sbm.bpp==16)
        if (pf.dwGBitMask==0x03e0) sbm.bpp=15;
  
      if (force_depth) sbm.bpp=force_depth;
  
  
      ret=bufsurf->Lock(NULL,&sd,DDLOCK_SURFACEMEMORYPTR,NULL);
      if (ret!=DD_OK)
      {
        sprintf (temp,"bufsurf->Lock returned %.8x\n(%.8x)\n sd is %p",
          ret,MAKE_DDHRESULT(0),sd.lpSurface);
        MessageBox(hWnd,temp,"bufsurf->Lock() Fail",MB_OK);
        exit(1);
      }
      sbm.pitch=sd.lPitch;
      sbm.data=(unsigned char *)sd.lpSurface;

      megad.one_frame_hints(&sbm,fmbuf,snd_size);
      mess_with_bm(&sbm);

      bufsurf->Unlock(sd.lpSurface);
    }
  }

  frame_count++;
  return 0;
}

static int paint_window()
{
  if (lpDDSPrimary==NULL) return 1;
  if (bufsurf==NULL) return 1;
  if (fullscreen)
  {
    int midx,midy;
    RECT srcrect={8,8,8+320,8+224};
    if (height<=200)
    { srcrect.top=8+12; srcrect.bottom=8+212; }

    if (srcrect.right >  srcrect.left+width)
        srcrect.right =  srcrect.left+width;
    if (srcrect.bottom >  srcrect.top+height)
        srcrect.bottom =  srcrect.top+height;
    ret=lpDDSPrimary->BltFast(0,0,bufsurf,&srcrect,0);
  }
  else
  {
    RECT destrect={0,0,320,224};
    RECT srcrect={8,8,8+320,8+224};
    ret=lpDDSPrimary->IsLost();
    if (ret)
    {
//    sprintf (temp,"IsLost ret %.8x (%+-d)\n",ret,ret-MAKE_DDHRESULT(0));
//    MessageBox(hWnd,temp,"Surface is lost",MB_OK);
      exit(1);
    }
  
    ret=GetWindowRect(hWnd,&destrect);
    destrect.top+=30;
    destrect.bottom-=10;
    destrect.left+=10;
    destrect.right-=10;
  
    if (!any_size)
    {
      int wid,hei;
      wid=destrect.right-destrect.left;
      hei=destrect.bottom-destrect.top;
           if (wid<320) ;
      else if (wid<320*2) wid=320;
      else if (wid<320*3) wid=320*2;
      else if (wid<320*4) wid=320*3;
    
           if (hei<224) ;
      else if (hei<224*2) hei=224;
      else if (hei<224*3) hei=224*2;
      else if (hei<224*4) hei=224*3;
    
      destrect.left=(destrect.right+destrect.left)/2;
      destrect.left-=wid/2;
      destrect.right=destrect.left+wid;
    
      destrect.top=(destrect.top+destrect.bottom)/2;
      destrect.top-=hei/2;
      destrect.bottom=destrect.top+hei;
    }
  
    ret=lpDDSPrimary->Blt(&destrect,bufsurf,&srcrect,0,NULL);
  }
  return 0;
}


static int md_save(int alert)
{
  FILE *hand=NULL;
  sprintf (temp,"save\\%.8s.gsx",gst_name(megad.romfilename));
  hand=fopen(temp,"wb");
  if (hand!=NULL)
  {
    megad.export_gst(hand); fclose(hand);
  }
  else
  {
    sprintf (temp+0x4000,"Couldn't save to '%s'\nTry making a directory called 'save'\n",temp);
    MessageBox(hWnd,temp+0x4000,"DGen Couldn't Save State",MB_OK);
  }
  return 0;
}

static int md_load(int alert)
{
  FILE *hand=NULL;
  sprintf (temp,"save\\%.8s.gsx",gst_name(megad.romfilename));
  hand=fopen(temp,"rb");
  if (hand!=NULL)
  {
    megad.import_gst(hand); fclose(hand);
  }
  else if (alert)
  {
    sprintf (temp+0x4000,"Couldn't load from '%s'\n",temp);
    MessageBox(hWnd,temp+0x4000,"DGen Couldn't Load State",MB_OK);
  }
  return 0;
}


// parses the config file
static int load_config(char *name)
{
  int done=0;
  FILE *hand;
  int i;
  int no_config_file=0;

  hand=fopen(name,"rt");
  if (hand==NULL)
  {
    no_config_file=1;
  }
  else
  {
    no_config_file=0;
    done=0;
    while (!done)
    {
      static char buf[256]="";
      if (fgets(buf,255,hand)==NULL) done=1;
      else
      {
        char *check_for=NULL;
        int slen=strlen(buf);

        // Knock off linefeeds, because they will mess up strings
        if (buf[slen-1]==10) {buf[slen-1]=0; slen--;}

#define IT_IS (strncmp(buf,check_for,strlen(check_for))==0)
#define VALUE (buf+strlen(check_for))
        // Graphics
        check_for="fullscreen";
        if (IT_IS) fullscreen=atoi(VALUE);
        check_for="width";
        if (IT_IS) width=atoi(VALUE);
        check_for="height";
        if (IT_IS) height=atoi(VALUE);
        check_for="depth";
        if (IT_IS) depth=atoi(VALUE);
        check_for="force_depth";
        if (IT_IS) force_depth=atoi(VALUE);
        check_for="brightness";
        if (IT_IS) brightness=atof(VALUE);
        check_for="contrast";
        if (IT_IS) contrast=atof(VALUE);
        check_for="umul";
        if (IT_IS) umul=atof(VALUE);
        check_for="vmul";
        if (IT_IS) vmul=atof(VALUE);
        check_for="crap_tv";
        if (IT_IS) crap_tv=atoi(VALUE);

        // Sound
        check_for="snd_rate";
        if (IT_IS) snd_rate=atoi(VALUE);
        check_for="snd_segs";
        if (IT_IS) snd_segs=atoi(VALUE);
        check_for="snd_distort";
        if (IT_IS) snd_distort=atof(VALUE);
        check_for="stereo16";
        if (IT_IS) stereo16=atoi(VALUE);

        // Misc
        check_for="virtual_fps";
        if (IT_IS) virtual_fps=atoi(VALUE);
        check_for="any_size";
        if (IT_IS) any_size=atoi(VALUE);

      }
    }
  
    fclose(hand);
  }

  return no_config_file;
}

static int unload_config(char *name)
{
  int i;
  FILE *hand=fopen(name,"wt");

  if (hand==NULL) return 1;

  fprintf(hand,"// Dave's DGEN v%s (DirectX) config file\n\n",VER);
  fprintf(hand,"// Note, 0=off, 1=on\n");

  fprintf(hand,"\n// Graphics\n");
  fprintf(hand,"fullscreen %d\n",fullscreen);
  fprintf(hand,"width %d\n",width);
  fprintf(hand,"height %d\n",height);
  fprintf(hand,"depth %d\n",depth);
  fprintf(hand,"force_depth %d\n",force_depth);
  fprintf(hand,"brightness %.2f\n",brightness);
  fprintf(hand,"contrast %.2f\n",contrast);
  fprintf(hand,"umul %.2f\n",umul);
  fprintf(hand,"vmul %.2f\n",vmul);
  fprintf(hand,"crap_tv %d\n",crap_tv);

  fprintf(hand,"\n\n// Sound (halve rate or increase segs if you have trouble)\n");
  fprintf(hand,"snd_rate %d\n",snd_rate);
  fprintf(hand,"snd_segs %d\n",snd_segs);
  fprintf(hand,"snd_distort %.2f\n",snd_distort);
  fprintf(hand,"stereo16 %d\n",stereo16);

  fprintf(hand,"\n\n// Misc.\n");
  fprintf(hand,"virtual_fps %d\n",virtual_fps);
  fprintf(hand,"any_size %d\n",any_size);

  fprintf(hand,"\n");
  fclose(hand);
  return 0;
}


/****************************************************************************
  FUNCTION: MainWndProc(HWND, UINT, WPARAM, LPARAM)
****************************************************************************/
long int  PASCAL  MainWndProc(HWND hWnd, UINT message,
						WPARAM wParam, LPARAM lParam)
{
  switch (message)
  {
    case WM_ACTIVATEAPP:
      // wParam true if we are switched to, false if user
      // switches to another program
      we_are_active = wParam;
    break;
    case WM_PAINT:
    {
      PAINTSTRUCT ps;
      HDC  hdc = BeginPaint(hWnd, &ps);
      // function calls to repaint main window go here
      paint_window();

      //RECT rect;
      //GetClientRect (hWnd, &rect);
      //SetTextAlign (hdc, TA_BASELINE | TA_CENTER);
      //TextOut(hdc, rect.right / 2, rect.bottom / 2,
      // "DGen", 4);
      EndPaint(hWnd,&ps);
    }
    break;

    case WM_QUIT:
    case WM_DESTROY:  // message: window being destroyed
      sound_exit();
      end_time=timeGetTime();
      bufsurf->Release();
      lpDDSPrimary->Release();
      lpdd->Release();
      md_save(0);
      /*
      {
        int timetaken;
        timetaken=end_time-start_time;
        if (timetaken)
        {
          sprintf (temp,"Frames per second was %.1f\n",
            (float)frame_count/((float)timetaken/1000.0));
          MessageBox(hWnd,temp,"DGen Performance",MB_OK);
        }
      }
      */

      unload_config("dgen.ini");
      if (debug_log) fclose(debug_log);
      PostQuitMessage(0);
    break;

    default:      // Passes it on if unproccessed
      return (DefWindowProc(hWnd, message, wParam, lParam));
  }
  return 0L;
}


int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
			  LPSTR lpCmdLine, int nCmdShow)
{
  MSG msg;      // message
  char def_name[32]="sonic1.smd";
  char *rom_name=def_name;

  if (!hPrevInstance) // Other instances of app running?
  if (!InitApplication(hInstance))  // Initialize shared things
	 return (FALSE); // Exits if unable to initialize

  /* Perform initializations that apply to a specific instance */

  if (!InitInstance(hInstance, nCmdShow))
	 return (FALSE);

//  debug_log=fopen("zzdebug.txt","wt");

  load_config("dgen.ini");

  sound_init();

  // Wait for a bit (let screen mode change) before creating directdraw
  // may fix +590 bugs?

  DWORD start,tme;
  tme=start=timeGetTime();
  while (tme<(start+100))
    tme=timeGetTime();

/*
  temp[0]=0;
  if (lpCmdLine!=NULL)
  {
    sprintf (temp+0,"Command line arguments were '%s'.\n",lpCmdLine);
  }
  MessageBox(hWnd,temp+0,"Info",MB_OK);
*/

  ret = DirectDrawCreate( NULL, &lpdd, NULL );
  if (ret!=DD_OK) exit(1);

  if (fullscreen)
    ret= lpdd->SetCooperativeLevel(hWnd, DDSCL_ALLOWREBOOT | DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWMODEX);
  else
    ret= lpdd->SetCooperativeLevel(hWnd, DDSCL_NORMAL);

  if (ret!=DD_OK)
  {
    sprintf (temp,"Return value was %x (%+-d)\n",ret,ret-MAKE_DDHRESULT(0));
    MessageBox(hWnd,temp,"SetCooperativeLevel() failed",MB_OK);
    exit(1);
  }

//  (Setting Video Mode)
  if (fullscreen)
  {
    ret = lpdd->SetDisplayMode(width, height, depth);
    if (ret!=DD_OK)
    {
      sprintf (temp,"Return value was %x (%+-d)\n",ret,ret-MAKE_DDHRESULT(0));
      MessageBox(hWnd,temp,"SetDisplayMode() failed",MB_OK);
      exit(1);
    }
  }

  create_primary_surface();
  if (!fullscreen) attach_clipper();
  create_bufsurf();

  if (fullscreen)
  {
/*
    if (depth==8)
    {
      ret=make_ddraw_pal(lpdd);
      if (ret!=0)
      {
        sprintf (temp,"Return value was %x (%+-d)\n",ret,ret-MAKE_DDHRESULT(0));
        MessageBox(hWnd,temp,"make_ddraw_pal(lpdd) results",MB_OK);
      }
      ret = lpDDSPrimary->SetPalette(ddpal);
      // this sets the palette for the primary surface
    }
*/
  }

  if (lpCmdLine!=NULL)
    if (lpCmdLine[0])
    {
      rom_name=lpCmdLine;
    }
  if (megad.load(rom_name)!=0)
  {
    sprintf (temp,
    "DGen couldn't load '%s'\n"
    "Put a valid rom name on the command-line\n"
    "(or drag and drop the rom file onto Dgen).",rom_name);
    MessageBox(hWnd,temp,"DGen Rom Load Failed",MB_OK);
    exit(1);
  }

  md_load(0);

  start_time=timeGetTime();
  int done=0;
  while (!done)

  {
    if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {
      if (msg.message == WM_QUIT) done=1;
      else if (msg.message == WM_DESTROY) done=1;
      else
      {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
      }
    }
    else
    {
      run_megadrive();
      paint_window();

      if (we_are_active)
      {
        static int last;
        if (!last)
        {
          if (KEY_DOWN('X')) crap_tv^=1;
          if (KEY_DOWN(0x74)) md_save(1);
          if (KEY_DOWN(0x76)) md_load(1);
        }
        last=KEY_DOWN('X')||KEY_DOWN(0x74)||KEY_DOWN(0x76);
  
        float vchange=0.05;
        if (KEY_DOWN(0x10)) vchange=-vchange;
        if (KEY_DOWN('V')) vmul+=vchange;
        if (KEY_DOWN('U')) umul+=vchange;
        if (KEY_DOWN('C')) contrast+=vchange;
        if (KEY_DOWN('B')) brightness+=vchange;
  
        if (KEY_DOWN(0x12)) if (KEY_DOWN('R')) megad.reset();
      }
    }
/*
    {
      megad.pad=0x303f; //      0x303f; = untouched pad

      if (we_are_active)
      {
        if (KEY_DOWN(0x26)) megad.pad&=~0x01;
        if (KEY_DOWN(0x28)) megad.pad&=~0x02;
        if (KEY_DOWN(0x25)) megad.pad&=~0x04;
        if (KEY_DOWN(0x27)) megad.pad&=~0x08;
  
        if (KEY_DOWN(0x0d)) megad.pad&=~0x2000;
        if (KEY_DOWN(0x41)) megad.pad&=~0x1000;
        if (KEY_DOWN(0x53)) megad.pad&=~0x10;
        if (KEY_DOWN(0x44)) megad.pad&=~0x20;
  
        {
//          {
//            FILE *hand=fopen("keys.log","at");
//            int i;
//            if (hand!=NULL)
//            {
//              for (i=0;i<256;i++)
//                if (KEY_DOWN(i))
//                  fprintf(hand,"%.2x ",i);
//              fprintf (hand,"\n----\n");
//              fclose(hand);
//            }
//          }


      {
        static DWORD lasttime=0,thistime;
        static int firsttime=1;
        static int extramsgone=0;
        int fps=60;

        int msgone,frgone,f;

        thistime=timeGetTime();
        msgone=thistime-lasttime;
        lasttime=thistime;

        if (firsttime) { msgone=0; firsttime=0; }
        msgone+=extramsgone;
        frgone=msgone*fps/1000;
        extramsgone=msgone-(frgone*1000/fps);

        if (frgone<0) frgone=0;
        else if (frgone>12) frgone=12;

        for (f=0;f<frgone;f++)
          megad.one_frame_hints();
      }

      paint_window();
    }
*/
  }
  return (msg.wParam);  // Returns the value from PostQuitMessage
}


