// DGen v1.04+
// DOS version

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <allegro.h>
#include "md.h"

FILE *debug_log=NULL;

int sound_is_okay=0;

char temp[0x2000]="";

volatile long long hz60=0;
void called_aimed_for_framerate_each_sec()
{
  hz60++;
}
END_OF_FUNCTION(called_aimed_for_framerate_each_sec);

static char *gst_name(char *fn)
{
  char *pt,*st;
  int len;

  temp[0x200]=0;
  pt=fn+strlen(fn)-1;
  while (pt>fn)
  {
    if (*pt=='\\') {pt++; break; }
    pt--;
  }
  st=pt;
  len=0;
  while (*pt!=0)
  {
    if (*pt=='.') break; 
    pt++; len++;
  }
  memcpy(temp+0x200,st,len);
  temp[0x200+len]=0;

  return temp+0x200;
}

static int md_save(md& megad, int alert)
{
  FILE *hand=NULL;
  sprintf (temp,"save\\%.8s.gsx",gst_name(megad.romfilename));
  hand=fopen(temp,"wb");
  if (hand!=NULL)
  {
    megad.export_gst(hand); fclose(hand);
  }
  else if (alert)
  {
    printf ("Couldn't save to '%s'\nTry making a directory called 'save'\n",temp);
    if (alert==2)
    {
      while (!kbhit())  ;
      if ((getxkey()&255)==27) exit(1);
    }
  }
  return 0;
}

static int md_load(md& megad,int alert)
{
  FILE *hand=NULL;
  sprintf (temp,"save\\%.8s.gsx",gst_name(megad.romfilename));
  hand=fopen(temp,"rb");
  if (hand!=NULL)
  {
    megad.import_gst(hand); fclose(hand);
  }
  else if (alert)
  {
    printf ("Couldn't load from '%s'\n",temp);
    while (!kbhit())  ;
    if ((getxkey()&255)==27) exit(1);
  }
  return 0;
}

static int drivname_to_value(char *s)
{
  if (s!=NULL)
  {
         if (strcasecmp(s,"vesa1")==0)  return GFX_VESA1;
    else if (strcasecmp(s,"vesa")==0)   return GFX_VESA1;
    else if (strcasecmp(s,"vesa2")==0)  return GFX_VESA2L;
    else if (strcasecmp(s,"vesa2l")==0) return GFX_VESA2L;
    else if (strcasecmp(s,"vesa2b")==0) return GFX_VESA2B;
    else if (strcasecmp(s,"vga")==0)    return GFX_VGA;
    else if (strcasecmp(s,"modex")==0)  return GFX_MODEX;
    else if (strcasecmp(s,"autodetect")==0)  return GFX_AUTODETECT;
  }
  return GFX_AUTODETECT;
}

static int print_help()
{
  printf(
  "  Syntax: DGEN <romname> [switches]\n"
  "  Description: DGEN-DOS v"VER"\n\n"
  "  Keys:\n"
  "    Pad1  Up/Down/Left/Right A,S,D and Enter=Start\n"
  "    Pad2  4-button Joystick/joypad\n"
  "    F1/F2/F3 stretch the screen (F1=fastest and default)\n"
  "    F4 enable split screen\n"
  "    Escape=quit, and Alt-R = reset\n"
  "  Switches:\n"
  "  -mode       specify screen mode by driver, resolution and colour depth\n"
  "        example:  -mode vesa1,640x480x16\n"
  "        example:  -mode 800x600\n"
  "  -nosplit    stop the middle of the screen messing up on games\n"
  "              which don't have top/bottom split screens\n"
  "\n"
  "  Homepage www.dtmnt.com\n"
  "  Dave's e-mail : dave@dtmnt.com\n"
  "\n"
  );
  return 0;
}

int main(int argc,char **argv)
{
  int grd=GFX_MODEX,grx=320,gry=240,grbpp=8;
//  int grd=GFX_VESA1,grx=640,gry=480,grbpp=8;
  char *romname=NULL;
  BITMAP *scr=NULL; int done=0;
  struct bmap scrbm;
  unsigned char mdpal[256]={0,0,0,0,255,255,255,255};
  int virtual_fps=60;
  int stretch=1,need_help=0;

  {
#ifdef DJGPP
#define STRCASECMP(a,b) strcasecmp(a,b)
#else
#define STRCASECMP(a,b) stricmp(a,b)
#endif
    int n; char *arg;
    n=1;
    while(n<argc)
    {
      arg=argv[n]; n++;
      if (*arg=='/'||*arg=='-')
      {
        char *info;
        // Switch
        if (STRCASECMP(arg+1,"mode")==0)
        {
          if (n<argc)
          {
            static char drivname[8]="";
            info=argv[n]; n++;
            if (sscanf(info,"%dx%dx%d",&grx,&gry,&grbpp)>=1)
              grd=GFX_AUTODETECT;
            else
            {
              if (sscanf(info,"%7[^,],%dx%dx%d",drivname,&grx,&gry,&grbpp)>=1)
              {
                if (drivname[0]) grd=drivname_to_value(drivname);
              }
            }
          }
        }
        else if (STRCASECMP(arg+1,"nosplit")==0)
        {
          extern int split_screen;
          split_screen=0;
        }
        else if (STRCASECMP(arg+1,"?")==0) need_help=1;
        else if (STRCASECMP(arg+1,"h")==0) need_help=1;
        else if (STRCASECMP(arg+1,"help")==0) need_help=1;
      }
      else
      {
        // Normal argument
        romname=arg;
      }
    }
  }

  if (romname==NULL) need_help=1;
  if (need_help) { print_help(); return 0; }

  allegro_init();

  printf ("DGen-DOS v" VER "\n");

  md megad;
  if (!megad.okay)
  {
    printf ("Megadrive init failed.\n");
    while (!kbhit())  ;
    if ((getxkey()&255)==27) exit(1);
  }

  if (megad.load(romname)!=0)
  {
    printf ("Error loading '%s'\n",romname);
    while (!kbhit())  ;
    if ((getxkey()&255)==27) exit(1);
  }
  else
    printf ("Loaded '%s' okay.\n",romname);

  md_load(megad,0);


  LOCK_VARIABLE(hz60);
  LOCK_FUNCTION(called_aimed_for_framerate_each_sec);
  if (
       install_int_ex
       (
         called_aimed_for_framerate_each_sec,
         BPS_TO_TIMER(virtual_fps)
       )
       !=0
     )
  {
    printf ("Error installing %d fps timer!\n",virtual_fps);
    printf ("Allegro's Reason: %s\n",allegro_error);
    while (!kbhit())  ;
    if ((getxkey()&255)==27) exit(1);
  }

  if (install_keyboard()!=0)
  {
    printf ("Error installing keyboard.\n");
    printf ("Allegro's Reason: %s\n",allegro_error);
    exit(1);
  }

  if (install_joystick(JOY_TYPE_4BUTTON)!=0)
  {
    printf ("Error installing 4-button joystick.\n");
    printf ("Allegro's Reason: %s\n",allegro_error);
    while (!kbhit())  ;
    if ((getxkey()&255)==27) exit(1);

    if (install_joystick(JOY_TYPE_AUTODETECT)!=0)
    {
      printf ("Error installing autodetect joystick.\n");
      printf ("Allegro's Reason: %s\n",allegro_error);
      while (!kbhit())  ;
      if ((getxkey()&255)==27) exit(1);
    }
  }
  if (install_timer()!=0)
    printf ("Error installing timer!\n");

  set_color_depth(grbpp);
  if (set_gfx_mode(grd,grx,gry,0,0)!=0)
  {
    printf ("Couldn't set %.8x x %d x %d x %d graphics mode.\n",grd,grx,gry,grbpp);
    printf ("Allegro's Reason: %s\n",allegro_error);
    exit(1);
  }
  scr=create_bitmap(320+16,224+16);
  if (scr==NULL)
  {
    allegro_exit();
    printf ("Couldn't make screen buffer.\n");
    exit(1);
  }

  scrbm.data=scr->line[0];
  scrbm.pitch=scr->line[1]-scr->line[0];
  scrbm.w=scr->w;
  scrbm.h=scr->h;
  scrbm.bpp=bitmap_color_depth(scr);

  hz60=0;
  while (!done)
  {
    int frames_todo=0;

    if (keypressed())
    {
      int key;
      key=readkey();
      if ((key&255)==27) { done=1; break; }
      if ((key>>8)==KEY_F1) { stretch=1; clear(screen); }
      if ((key>>8)==KEY_F2) { stretch=2; clear(screen); }
      if ((key>>8)==KEY_F3) { stretch=3; clear(screen); }
      if ((key>>8)==KEY_F4)
      {
        extern int split_screen;
        split_screen=!split_screen;
      }
    }

    if (key[KEY_ALT  ]) if (key[KEY_R  ]) megad.reset();

    // Define megad pad

    megad.pad[0]=megad.pad[1]=0x303f;
    if (key[KEY_UP   ]) megad.pad[0]&=~0x01;
    if (key[KEY_DOWN ]) megad.pad[0]&=~0x02;
    if (key[KEY_LEFT ]) megad.pad[0]&=~0x04;
    if (key[KEY_RIGHT]) megad.pad[0]&=~0x08;
    if (key[KEY_ENTER]) megad.pad[0]&=~0x2000;
    if (key[KEY_A    ]) megad.pad[0]&=~0x1000;
    if (key[KEY_S    ]) megad.pad[0]&=~0x10;
    if (key[KEY_D    ]) megad.pad[0]&=~0x20;

    poll_joystick();
    if (joy_up        ) megad.pad[1]&=~0x01;
    if (joy_down      ) megad.pad[1]&=~0x02;
    if (joy_left      ) megad.pad[1]&=~0x04;
    if (joy_right     ) megad.pad[1]&=~0x08;
    if (joy_b2        ) megad.pad[1]&=~0x2000;
    if (joy_b1        ) megad.pad[1]&=~0x1000;
    if (joy_b3        ) megad.pad[1]&=~0x10;
    if (joy_b4        ) megad.pad[1]&=~0x20;

    {
      static int last_hz60=0;
      frames_todo=hz60-last_hz60;
      last_hz60=hz60;
    }
    if (frames_todo>20) frames_todo=20;

    // Do all but one frame
    while (frames_todo>1)
    {
      megad.one_frame_hints(NULL,NULL,NULL,0);
      frames_todo--;
    }  

    if (frames_todo>0)
    {
      if (grbpp<=8)
      {
        megad.one_frame_hints(&scrbm,mdpal,NULL,0);
        {
          int i=0;
          for (i=0;i<64;i++)
          {
            RGB rgb;
            rgb.r=mdpal[i*4+0]>>2;
            rgb.g=mdpal[i*4+1]>>2;
            rgb.b=mdpal[i*4+2]>>2;
            set_color(i,&rgb);
          }
        }
      }
      else
      {
        megad.one_frame_hints(&scrbm,NULL,NULL,0);
      }
      frames_todo--;
    }

    if (stretch==2)
      stretch_blit(scr,screen,8,8,320,224,grx/4,0,grx/2,gry);
    else if (stretch==3)
      stretch_blit(scr,screen,8,8,320,224,0,0,grx,gry);
    else
      blit(scr,screen,8,8,grx/2-160,gry/2-112,320,224);
/*
    {
      int y;
      for (y=0;y<224;y++)
      {
        blit(scr,screen,8,8+y,grx/2-160,gry/2-224+y*2,320,1);
//        stretch_blit(scr,screen,8,8+y,320,1,0,gry/2-224+y*2,grx,1);
      }
    }
*/

  }

  if (scr!=NULL) destroy_bitmap(scr);
  allegro_exit();

  md_save(megad,1);
  megad.unplug();

  return 0;
}

