// DGen v1.06+
// MYFM.CPP - interface to YM2612Update

#include <stdio.h>
#include <stdlib.h>
#include "md.h"

extern int sound_is_okay;
extern FILE *debug_log;

// md.h also has include fm.h

// REMEMBER NOT TO USE ANY STATIC variables, because they
// will exist thoughout ALL megadrives!

int md::myfm_write(int a,int v)
{
  int sid=0;
  int mame_can_have_it=1;
  a&=3;

  sid=(a&2)?1:0;

  if ((a&1)==0) fm_sel[sid]=v;
  else
  {
    // stash 24-27 values - we need them
    if ((fm_sel[sid]&0xfc)==0x24)
    {
      fm_reg[sid] [fm_sel[sid]&3] = v;
      mame_can_have_it=0;
    }
    if (fm_sel[sid]==0x27)
    {
      if (v&0x10) fm_tover[sid]&=~1;
      if (v&0x20) fm_tover[sid]&=~2;
      // timer ack?
      mame_can_have_it=0;
    }
  }

  if (sound_is_okay && mame_can_have_it) YM2612Write(0,a&3,v);

  return 0;
}

int md::myfm_read(int a)
{
  int sid;

//  if (sound_is_okay) ret=YM2612Read(0,a&3);

  (void)a;

  for (sid=0;sid<2;sid++)
  {
    int amax=0,bmax=0;

    // period of timer a is
    // 18 * (1024 - ((fm_reg[0][0]<<2)+(fm_reg[0][1])&3))) microsecs
    // Our raster lasts 63.61323 microseconds
    amax=18 * (1024 -  ((fm_reg[0][0]<<2)+(fm_reg[0][1]&3)) );
    amax/=63;
    if (amax<=0) amax=0;
  
    bmax=288*(256-fm_reg[0][2]);
    bmax/=63;
    if (bmax<=0) bmax=0;
  
    if (ras_fm_ticker[0]>=amax)
    { fm_tover[sid]|=1; ras_fm_ticker[sid*2+0]-=amax; }
  
    if (ras_fm_ticker[1]>=bmax)
    { fm_tover[sid]|=2; ras_fm_ticker[sid*2+1]-=bmax; }
  }

  return fm_tover[0];
}

int md::mysn_write(int d)
{
  if (sound_is_okay) SN76496Write(0,d);
  return 0;
}
