#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "md.h"

// 'raw' version - should run on anything, but not
// very useful other than for testing
FILE *debug_log=NULL;
int sound_is_okay=0;

int main(int argc,char **argv)
{
  char defname[]="sonic1.smd";
  char *romname=defname;

  char defppm[]="dgen.ppm";
  char *ppmname=defppm;
  int frames=3*60,i;

  printf ("DGen v"VER" 'raw' test program.\n");
  printf ("by Dave: dave@dtmnt.com www.dtmnt.com\n");

  if (argc>=2) romname=argv[1];
  if (argc>=3) frames=atoi(argv[2]);
  if (argc>=4) ppmname=argv[3];
 
  md megad;
  if (!megad.okay())
  { printf ("WARNING: Megadrive init failed.\n"); fflush(stdout); }

  megad.pad[0]=megad.pad[1]=0x303f;

  if (megad.load(romname)!=0)
  {
    printf ("Error loading '%s'\n",romname);
    fflush(stdout);
    exit(1);
  }
  else
  {
    printf ("Loaded '%s' okay.\n",romname);
    fflush(stdout);
  }

  printf ("running md for %d frames...\n",frames-1);
  fflush(stdout);
  for (i=0;i<frames-1;i++)
  {
    megad.one_frame_hints(NULL,NULL,NULL,0);
    printf ("frame %4d\r",i);
    fflush(stdout);
  }
  printf ("frame %4d done\n",i);

  printf ("rendering and saving frame %d to %s\n",frames,ppmname);
  {
    struct bmap bm;
    int x,y; unsigned char *pb;
    FILE *hand;

    // make bitmaps for the screen buffer
    bm.w=320+16;
    bm.h=224+16;
    bm.bpp=24;
    bm.pitch=bm.w*3;
    bm.data=(unsigned char *)malloc(bm.h*bm.pitch);
    if (bm.data==NULL)
    {
      printf ("Couldn't allocate bitmap.\n");
      exit(1);
    }
    memset(bm.data,0,bm.h*bm.pitch);

    megad.one_frame_hints(&bm,NULL,NULL,0);

    hand=fopen(ppmname,"wb");
    if (hand==NULL)
    {
      printf ("Couldn't open %s\n",ppmname);
      exit(1);
    }

    pb=bm.data;
    fprintf (hand,"P3\n%d %d\n255\n",bm.w,bm.h);
    for (y=0;y<bm.h;y++)
    {
      for (x=0;x<bm.w;x++)
      {
        fprintf (hand,"%3d %3d %3d ",*pb++,*pb++,*pb++);
        if ((x&15)==15)  fprintf (hand,"\n");
      }
      fprintf (hand,"\n");
    }
    fclose(hand);

    printf ("saved to %s\n",ppmname);

  }

  return 0;
}
